module IT_hip
def self.hide_invisible_polygons
  	model = Sketchup.active_model

	# model.rendering_options["DisplayColorByLayer"]=true
	selection = model.selection
	selection = model.active_entities if selection.empty?
	
	prompts = ["Test type","Hide Component","Hide Polygons"]
        defaults = ["Camera","Yes","Yes"]
        values = ["Full|Camera|Short","Yes|No","Yes|No"]
		results = UI.inputbox( prompts, defaults, values, "Select the test type")
			return nil if not results
        tip = results[0]
		hide_component = results[1]
		hide_polygons = results[2]
	case tip
        when 'Full'
		@AXES = { "y" => Y_AXIS, "z" => Z_AXIS, "x" => X_AXIS, "y2" => Y_AXIS.reverse, "x2" => X_AXIS.reverse } # "z2" => Z_AXIS.reverse,
		when 'Short'
		@AXES = { "y" => Y_AXIS, "z" => Z_AXIS, "camera" => model.active_view.camera.eye } # "z2" => Z_AXIS.reverse,
		when 'Camera'
		@AXES = { "camera" => model.active_view.camera.eye}
	end # case
	model.start_operation("Hide invisible polygons", true) rescue model.start_operation("Hide invisible polygons")
	@tested_invis_verts=[]
	@tested_verts=[]
    @hide_faces=[]
	@hide_component=[]
	
	new_layer = model.layers.add('Invisible_Polygons') if hide_polygons == 'Yes'
	new_layer2 = model.layers.add('Invisible_Component') if hide_component == 'Yes'

	
	start_time = Time.now
	Sketchup.set_status_text "Program is running..."

	if (hide_polygons == 'No') and (hide_component == 'No')
	  UI.messagebox("Operation canceled.
Please select the correct values!")
	  return
	end
  all_verts=[]
  all_faces=[]
  all_component_group=[]
  @corner = (0..7).to_a
  @max_comp_test = @AXES.size*@corner.size*3
    selection.each{|entity|
    if (entity.class==Sketchup::Face) and (hide_polygons == 'Yes')
  all_verts << entity.vertices 
  all_faces << entity
  end#if
  all_component_group << entity if (entity.class==Sketchup::ComponentInstance) if (hide_component == 'Yes') 
  all_component_group << entity if (entity.class==Sketchup::Group) if (hide_component == 'Yes')
  }
  if (all_faces == []) and (all_component_group == [])
  UI.messagebox("Select any polygons!")
  return 
  end # if
  Sketchup.set_status_text "Program is running... #{all_faces.size} - faces found"
all_verts.flatten!.uniq! if all_verts !=[]

all_verts.each {|entity|viz_test_vertex(entity)}
all_faces.each {|entity|viz_test(entity)}
all_component_group.each {|entity|viz_test_component(entity)} if all_component_group!=[] and hide_component == 'Yes'
    model.selection.clear
	new_layer.visible = false if hide_polygons == 'Yes'
	new_layer2.visible = false if hide_component == 'Yes'
	end_time = Time.now
puts "hide #{@hide_faces.size}  all: #{all_faces.size}"
puts "hide  component #{@hide_component.size}  all: #{all_component_group.size}" if hide_component == 'Yes'

lead_time = (end_time - start_time.to_f).strftime(" Total Elapsed Time: Min %M: Sec: %S.%L")
 
puts lead_time
  	model.commit_operation
Sketchup.set_status_text lead_time
end	


def self.viz_test (face)
verts=[]
invis_verts=[]
verts=face.vertices
verts.each{|v| invis_verts=invis_verts.push(v) if @tested_invis_verts.include?(v)}
 if verts.size == invis_verts.size
	face.layer = 'Invisible_Polygons'
    @hide_faces << face
    edge = face.edges
	edge.each{|e| e.visible = false}
 end #if
end # def

def self.viz_test_vertex (vertex_ent)
rayt =[]
		@AXES.each_value{|axis_value| rayt=rayt.push(Sketchup.active_model.raytest(vertex_ent.position, axis_value)) }
rayt.compact!
	if rayt.size == @AXES.size
		@tested_invis_verts=@tested_invis_verts.push(vertex_ent)
	end
@tested_verts=@tested_verts.push(vertex_ent)
end # def

def self.viz_test_component (component_ent)

boundingBox=component_ent.bounds
 component_ent.visible = false
 
 corner_rayt = []
		@AXES.each_value {|axis_value|
			@corner.each{|cor|	
				corner_rayt << Sketchup.active_model.raytest(boundingBox.corner(cor), axis_value)
			}
		}		
		component_ent.visible = true
# puts "corner_rayt = #{corner_rayt}"
corner_rayt_test = corner_rayt.flatten.compact.size
# puts "corner_rayt_test = #{corner_rayt_test}"
# puts "max_comp_test = #{@max_comp_test}"
# p
# p

	if corner_rayt_test == @max_comp_test
	@hide_component << component_ent
		component_ent.layer = 'Invisible_Component'
	end
end # def

end # IT_hip

if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("Hide Invisible Polygons and Component") { IT_hip.hide_invisible_polygons }
	end
else
	if !file_loaded?('ithil_menu_loader') then
		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
		$ithil_menu.add_item("Hide Invisible Polygons and Component") { IT_hip.hide_invisible_polygons }
	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)

